import { ActionFormData, } from '@minecraft/server-ui'
import { world, EntityBreathableComponent, system, Vector, ItemEnchantsComponent, MinecraftEffectTypes, MinecraftBlockTypes } from "@minecraft/server";
import { ModalFormData } from '@minecraft/server-ui'

onscriptsreload()

system.runInterval(() => {
    world.getDimension("overworld").runCommandAsync('scoreboard players set @a scripTest 50')
    world.getDimension("overworld").runCommandAsync('scoreboard objectives remove scripTest1')
})

function onscriptsreload() {
    var fechaInicial = new Date(Date.now());
    // Restar 6 horas a la fecha inicial
    fechaInicial.setHours(fechaInicial.getHours() + -1);

    // Obtener las partes de la hora
    var horas = fechaInicial.getHours();
    var minutos = fechaInicial.getMinutes();
    var segundos = fechaInicial.getSeconds();

    // Formatear las partes de la hora
    var horaFormateada = horas.toString().padStart(2, '0');
    var minutosFormateados = minutos.toString().padStart(2, '0');
    var segundosFormateados = segundos.toString().padStart(2, '0');
    world.sendMessage(`§8[§a!§8] §7Reloading Scripts §f- §7${horaFormateada + ":" + minutosFormateados + ":" + segundosFormateados}`);
}

function calculateSpeed(Vx, Vy, Vz) {
    return Math.sqrt(Vx ** 2 + Vy ** 2 + Vz ** 2);
}


system.runInterval(() => {
    for (let player of world.getPlayers()) {
        if (player.hasTag("GMTC")) {
            sethouer(player)

            player.runCommandAsync(`tag @s remove GMTC`)
        }
        if (player.hasTag("ShowRealTimeConfig")) {
            player.runCommandAsync(`tag @e remove "ShowRealTimeConfig"`)
            showRealTime(player)
        }
    }
}
)



function sethouer(player) {
    system.run(() => {
        const form = new ModalFormData()
            .title(`§l§9§k!!§r §l§9Set Houer §k!!§r`)
            .slider(`§9Select the GMT`, -7, 7, 1, 0) ///0
            .show(player).then(result => {
                const gmt = result.formValues[0]
                player.runCommandAsync(`scoreboard players set @e[type=satanic:data_save] ZH ${gmt}`)
                player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§9[TIP] To restart the addon execute the function RT/start again."}]}`)
                player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§l§9To put the time on the screen or change the GMT execute de function RT/config."}]}`)
            }
            )
    })
}

function showRealTime(player) {
    system.run(() => {
            const form = new ModalFormData()
                .title(`§l§9§k!!§r §l§9Show Real Time Config §k!!§r`)
                .slider(`§9Select the GMT`, -7, 7, 1, getScore(player, "ZH")) ///0
                .toggle('§l§9Show real time on the screen', player.hasTag('RealTimeShow'))
                .toggle('§l§9Format 1 - 24', !player.hasTag('Format1to24'))
                .show(player).then(result => {
                    const gmt = result.formValues[0]
                    player.runCommandAsync(`scoreboard players set @e[type=satanic:data_save] ZH ${gmt}`)

                    if (result.formValues[1] === true) {
                        player.runCommandAsync(`tag @e[type=satanic:data_save] add RealTimeShow`)
                    }
                    if (result.formValues[1] === false) {
                        player.runCommandAsync(`tag @e[type=satanic:data_save] remove RealTimeShow`)
                        player.runCommandAsync(`tag @s add "deleaterealtimeinscreen"`)
                    } 
                    
                    if (result.formValues[2] === true) {
                        player.runCommandAsync(`tag @e[type=satanic:data_save] remove Format1to24`)
                    }
                    if (result.formValues[2] === false) {
                        player.runCommandAsync(`tag @e[type=satanic:data_save] add Format1to24`)
                    }
                }
                )
        }
    )}



system.runInterval(() => {
    world.getDimension("overworld").runCommandAsync(`tag @e[type=satanic:data_save] add satanic_data_save`)
    const entities = Array.from(world.getDimension("overworld").getEntities());
    for (const entity of entities) {
        if (entity.hasTag("satanic_data_save")) {

            var fechaInicial = new Date(Date.now());
            // Restar 6 horas a la fecha inicial
            fechaInicial.setHours(fechaInicial.getHours() + getScore(entity, "ZH"));

            // Obtener las partes de la hora
            var horas = fechaInicial.getHours();
            var minutos = fechaInicial.getMinutes();
            var segundos = fechaInicial.getSeconds();

            let ticks_dia = ((Math.floor((((horas * 3600 + minutos * 60 + segundos) / 86400) * 24000) % 24000)) + 18000) % 24000;
            entity.runCommandAsync(`time set ${ticks_dia}`)
        }
    }
})

function getScore(target, objective) {
    try {
        return world.scoreboard.getObjective(objective).getScore(typeof target === 'string' ? oB.getParticipants().find(pT => pT.displayName == target) : target.scoreboardIdentity)
    } catch {
        return 0
    }
}

system.runInterval(() => {
    world.getDimension("overworld").runCommandAsync(`tp @e[type=satanic:data_save] 0 300 0`)

    world.getDimension("overworld").runCommandAsync(`execute as @e[type=satanic:data_save,tag=RealTimeShow] at @s run tag @a add "RealTimeShow"`)
    world.getDimension("overworld").runCommandAsync(`execute as @e[type=satanic:data_save,tag=!RealTimeShow] at @s run tag @a remove "RealTimeShow"`)

    world.getDimension("overworld").runCommandAsync(`execute as @e[type=satanic:data_save,tag=Format1to24] at @s run tag @a add "Format1to24"`)
    world.getDimension("overworld").runCommandAsync(`execute as @e[type=satanic:data_save,tag=!Format1to24] at @s run tag @a remove "Format1to24"`)
    
    world.getDimension("overworld").runCommandAsync(`scoreboard players operation @a ZH = @e[type=satanic:data_save] ZH`)
})

system.runInterval(() => {
    world.getDimension("overworld").runCommandAsync(`tag @e[type=satanic:data_save] add satanic_data_save`)
    const entities = Array.from(world.getDimension("overworld").getEntities());
    for (const entity of entities) {
        if (entity.hasTag("RealTimeShow")) {

            var fechaInicial = new Date(Date.now());
            // Restar 6 horas a la fecha inicial
            fechaInicial.setHours(fechaInicial.getHours() + getScore(entity, "ZH"));

            // Obtener las partes de la hora
            var horas = fechaInicial.getHours();
            var minutos = fechaInicial.getMinutes();
            var segundos = fechaInicial.getSeconds();

            var horaFormateada
            var minutosFormateados
            var segundosFormateados

            var ampm
            if (entity.hasTag("Format1to24")) {
                var horaFormateada = horas.toString().padStart(2, '0').replace(/13/g, "1").replace(/14/g, "2").replace(/15/g, "3").replace(/16/g, "4").replace(/17/g, "5").replace(/18/g, "6").replace(/19/g, "7").replace(/20/g, "8").replace(/21/g, "9").replace(/22/g, "10").replace(/23/g, "11").replace(/00/g, "12")
                var minutosFormateados = minutos.toString().padStart(2, '0');
                var segundosFormateados = segundos.toString().padStart(2, '0');
                if ((horas) >= 0 && (horas) <= 12) {
                    var ampm = " a.m."
                }
                if ((horas) >= 13 && (horas) <= 23) {
                    var ampm = " p.m."
                }
            } else {
                var horaFormateada = horas.toString().padStart(2, '0').replace(/00/g, "24")
                var minutosFormateados = minutos.toString().padStart(2, '0');
                var segundosFormateados = segundos.toString().padStart(2, '0');
                var ampm = ""
            }
            entity.runCommandAsync(`scoreboard objectives remove RealTime`)
            entity.runCommandAsync(`scoreboard objectives add RealTime dummy "§9Time §7${horaFormateada}§9:§7${minutosFormateados}§9:§7${segundosFormateados}§9${ampm}§r"`)
            entity.runCommandAsync(`scoreboard objectives setdisplay sidebar RealTime`)
        }
    }
})